-- jednoducha telemetrie auta
-- rychlost a dve teploty (esc a baterka?)
--
local rpm2kph = 0.0

local kph = 0.0
local rpm = 0.0
local t1 = 0.0
local t2 = 0.0
local maxKph = 0.0
local maxT1 = 0.0
local maxT2 = 0.0
local allbat = 0.0
local bat = 0.0
local maxSpeed = 430

-- Called once when script is loaded
local function init()
  LINE_COLOR = 8
  rpm2kph = 0.0037077 -- kmh = 14/2400 * PI * 0.0562 * 3.6
                      --                       ^ wheel diam
end

-- Runs in background when screen is not visible
local function background()
  rpm = getValue("RPM")
  kph = rpm * rpm2kph  -- math.floor((rpm * rpm2kph) * 100 ) / 100
  setTelemetryValue(42,1,0,kph*10, 7, 1, "spd1") -- #002A unit kph
end

local function run(EVT_PAGE_LONG)
  background()
  t1 = getValue("Tmp1") * 10
  t2 = getValue("Tmp2") * 10
  kph = kph * 10
  maxKph = getValue("RPM+")*rpm2kph * 10
  maxT1 = getValue("Tmp1+") * 10
  maxT2 = getValue("Tmp2+") * 10
  allbat = getValue("Cels")
  bat = 0
  if (type(allbat) == "table") then
    for k, v in ipairs(allbat) do
      bat = bat + v
    end
  else
    bat = allbat
  end

  bat = bat * 10 -- kvuli zobrazeni

  lcd.clear()
  -- carky
  lcd.drawLine(0,8,128,8,SOLID,LINE_COLOR)
  lcd.drawLine(90,0,90,64, SOLID, LINE_COLOR)
  lcd.drawLine(90,38,128,38, SOLID, LINE_COLOR)
  lcd.drawLine(0,48, 90, 48, SOLID, LINE_COLOR)

  -- rychlost
  lcd.drawText(5,0,"Speed",SMLSIZE)
  if (kph < 100) then
    lcd.drawNumber(14,12, kph,DBLSIZE+PREC1)
  else
    lcd.drawNumber(5,12, kph,DBLSIZE+PREC1)
  end
  lcd.drawText(lcd.getLastPos() + 10,12,"kph",DBLSIZE)
  lcd.drawNumber(23, 38, maxKph, PREC1+INVERS)
  lcd.drawText(lcd.getLastPos() + 1, 38, "  kph", INVERS) -- normal size

  -- teplota ESC
  lcd.drawText(95,0,"ESC",SMLSIZE)
  lcd.drawNumber(95,12,t1,SMLSIZE+PREC1)
  lcd.drawText(lcd.getLastPos() + 1,12,"@C",SMLSIZE)
  lcd.drawNumber(95, 20, maxT1, SMLSIZE+PREC1+INVERS)
  lcd.drawText(lcd.getLastPos() + 1, 20, "@C", SMLSIZE+INVERS)

  -- teplota 2 (baterka?)
  lcd.drawText(95,31,"ACU:",SMLSIZE)
  lcd.drawNumber(95,42,t2,SMLSIZE+PREC1)
  lcd.drawText(lcd.getLastPos() + 1,42,"@C",SMLSIZE)
  lcd.drawNumber(95, 50, maxT2, SMLSIZE+PREC1+INVERS)
  lcd.drawText(lcd.getLastPos() + 1, 50, "@C", SMLSIZE+INVERS)

  -- napeti baterie
  lcd.drawText(5, 53, "Bat:", 0)
  lcd.drawNumber(lcd.getLastPos() + 10, 51, bat, MIDSIZE+PREC1)
  lcd.drawText(lcd.getLastPos() + 1, 51, "V", MIDSIZE)

  -- jednoduchy bar
  lcd.drawGauge(1, 30, 88, 5, kph, maxSpeed)

end

return { init=init, background=background, run=run }